"""
 functions to match a bunch of fragment descriptors from a file

No user-servicable parts inside.  ;-)

"""
from __future__ import annotations
import os as os
from rdkix import Chem
from rdkix import RDConfig
__all__ = ['Chem', 'RDConfig', 'defaultPatternFileName', 'fn', 'fns', 'name', 'os']
def _CountMatches(mol, patt, unique = True):
    ...
def _LoadPatterns(fileName = None):
    ...
defaultPatternFileName: str = 'C:/rdkix/build/temp.win-amd64-cpython-38/Release/rdkix_install\\share/RDKix\\Data\\FragmentDescriptors.csv'
fn = None
fns: list  # value = [('fr_C_O', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A43310>), ('fr_C_O_noCOO', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A433A0>), ('fr_Al_OH', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A43430>), ('fr_Ar_OH', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A434C0>), ('fr_methoxy', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A43550>), ('fr_oxime', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A435E0>), ('fr_ester', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A43670>), ('fr_Al_COO', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A43700>), ('fr_Ar_COO', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A43790>), ('fr_COO', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A43820>), ('fr_COO2', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A438B0>), ('fr_ketone', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A43940>), ('fr_ether', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A439D0>), ('fr_phenol', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A43A60>), ('fr_aldehyde', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A43AF0>), ('fr_quatN', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A43B80>), ('fr_NH2', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A43C10>), ('fr_NH1', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A43CA0>), ('fr_NH0', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A43D30>), ('fr_Ar_N', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A43DC0>), ('fr_Ar_NH', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A43E50>), ('fr_aniline', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A43EE0>), ('fr_Imine', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A43F70>), ('fr_nitrile', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49040>), ('fr_hdrzine', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49160>), ('fr_hdrzone', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A490D0>), ('fr_nitroso', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A491F0>), ('fr_N_O', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49280>), ('fr_nitro', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49310>), ('fr_azo', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A493A0>), ('fr_diazo', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49430>), ('fr_azide', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A494C0>), ('fr_amide', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49550>), ('fr_priamide', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A495E0>), ('fr_amidine', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49670>), ('fr_guanido', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49700>), ('fr_Nhpyrrole', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49790>), ('fr_imide', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49820>), ('fr_isocyan', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A498B0>), ('fr_isothiocyan', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49940>), ('fr_thiocyan', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A499D0>), ('fr_halogen', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49A60>), ('fr_alkyl_halide', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49AF0>), ('fr_sulfide', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49B80>), ('fr_SH', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49C10>), ('fr_C_S', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49CA0>), ('fr_sulfone', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49D30>), ('fr_sulfonamd', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49DC0>), ('fr_prisulfonamd', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49E50>), ('fr_barbitur', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49EE0>), ('fr_urea', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A49F70>), ('fr_term_acetylene', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4C040>), ('fr_imidazole', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4C0D0>), ('fr_furan', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4C160>), ('fr_thiophene', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4C1F0>), ('fr_thiazole', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4C280>), ('fr_oxazole', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4C310>), ('fr_pyridine', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4C3A0>), ('fr_piperdine', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4C430>), ('fr_piperzine', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4C4C0>), ('fr_morpholine', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4C550>), ('fr_lactam', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4C5E0>), ('fr_lactone', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4C670>), ('fr_tetrazole', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4C700>), ('fr_epoxide', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4C790>), ('fr_unbrch_alkane', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4C940>), ('fr_bicyclic', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4C820>), ('fr_benzene', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4C9D0>), ('fr_phos_acid', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4CA60>), ('fr_phos_ester', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4CAF0>), ('fr_nitro_arom', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4CB80>), ('fr_nitro_arom_nonortho', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4CC10>), ('fr_dihydropyridine', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4CD30>), ('fr_phenol_noOrthoHbond', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4CCA0>), ('fr_Al_OH_noTert', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4CDC0>), ('fr_benzodiazepine', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4CE50>), ('fr_para_hydroxylation', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4CEE0>), ('fr_allylic_oxid', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A52040>), ('fr_aryl_methyl', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A4CF70>), ('fr_Ndealkylation1', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A520D0>), ('fr_Ndealkylation2', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A52160>), ('fr_alkyl_carbamate', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A521F0>), ('fr_ketone_Topliss', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A52280>), ('fr_ArN', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A52310>), ('fr_HOCCN', <function _LoadPatterns.<locals>.<lambda> at 0x0000024AF7A523A0>)]
name: str = 'fr_HOCCN'
